import { XMLElem, type IToXML } from "@/util/XmlElem";
import { type UABaseNodeOptions } from "./UABaseNode";
import type { NamespaceTable } from "./NameSpaceTable";
import type { IAddressSpace } from "./IAddressSpace";
import { UAType } from "./UAType";
export class UADataType extends UAType implements IToXML {
//TODO definition

    constructor(options: UATypeOptions) {
        super(options);
        Object.assign(this, options);  
        this.nodeClass="UADataType";
    }
    toXML(lnst:NamespaceTable, gnst:NamespaceTable): XMLElem {
        const elem=super.toXML(lnst, gnst);
        elem.name=this.nodeClass;
        elem.attr("Purpose", this.purpose);
        elem.attr('IsAbstract', this.isAbstract);

        return elem;    
    }
    static  fromXML(uaObject: any, addressSpace: IAddressSpace): UADataType{
        const bn=super.fromXML(uaObject, addressSpace) as UATypeOptions

        return new UADataType(bn as UATypeOptions);    
    }
}

export interface UATypeOptions extends UABaseNodeOptions{

}