import { XMLElem } from "@/util/XmlElem";
import type { NamespaceTable } from "./NameSpaceTable";
import { type UABaseNodeOptions } from "./UABaseNode";
import type { IAddressSpace } from "./IAddressSpace";
import { UAType, type UATypeOptions } from "./UAType";

export class UAObjectType extends UAType{
  
    constructor(options: UAObjectTypeOptions) {
        super(options);
        Object.assign(this, options);  
        this.nodeClass="UAObjectType";
    }

    static  fromXML(xmlObjType: any, addressSpace: IAddressSpace): UAObjectType{
        const bn=super.fromXML(xmlObjType, addressSpace)
        return new UAObjectType(bn as UABaseNodeOptions);
    }

    toXML(lnst:NamespaceTable, gnst:NamespaceTable): XMLElem {
        const elem =super.toXML(lnst, gnst);
        elem.name=this.nodeClass;
        return elem;
    }
}

export interface UAObjectTypeOptions extends UATypeOptions{
}
